
public class HugeInt {

    int digits[];
    int length;

    HugeInt(long val) {
        length = 10;
        digits = new int[length];

        int pos = 0;

        while (val > 0) {
            int d = (int) (val % 10);

            if (pos >= length) {
                extend();
            }

            digits[pos++] = d;


            val /= 10;
        }


    }

    public String toString() {
        String res = "";

        for (int i = length - 1; i >= 0; i--) {
            res += Integer.toString(digits[i]);
        }

        return res;
    }

    final void extend() {
        int newDigits[] = new int[length * 2];

        for (int i = 0; i < length; i++) {
            newDigits[i] = digits[i];
        }

        digits = newDigits;
        length *= 2;
    }

    public void multiply(int val) {
        int carry = 0;
        int pos = 0;

        while (pos < length || carry > 0) {
            if (pos >= length) {
                extend();
            }
            int d = digits[pos] *val + carry;

            carry = d / 10;
            digits[pos]=d%10;
            pos++;
        }

    }
}
