
public class Queue {

    int T[];
    int start;
    int end;
    boolean empty;
    
    Queue() {
        T = new int[100];
        start = 0;
        end =-1;
        empty=true;
    }

    void enqueue(int val) throws Exception {
        if (!empty && end+1 % 100 == start) {
            throw new Exception("Queue full");
        }
        T[++end] = val;
        
        empty=false;
        
        end %= 100;
    }

    int dequeue() throws Exception {
        if (empty) {
            throw new Exception("Queue empty");
        }

        if(start==end) empty=true;
        int res=T[start++];
        
        start %= 100;
        
        return res;
    }
}
